# $Id: oracle-instantclient.spec 27 2006-04-24 13:24:02Z matthias $

# Don't enable debuginfo package, what's left to strip shouldn't be!
%define debug_package %{nil}

# Define to use the basiclite source and create a basiclite package instead of
# the full-featured basic.
#define lite lite

%ifarch i386
%define ora_date -20060331
%define ora_arch linux32
%endif

%ifarch x86_64
%define ora_date -20060228
%define ora_arch linux-x86-64
%endif

%define ora_dir instantclient_10_2

Summary: Instant Client for Oracle Database 10g
Name: oracle-instantclient
Version: 10.2.0.2
Release: 2
Group: Applications/Databases
License: Oracle
URL: http://www.oracle.com/technology/tech/oci/instantclient/instantclient.html
Source0: instantclient-basic%{?lite}-%{ora_arch}-%{version}%{?ora_date}.zip
Source1: instantclient-jdbc-%{ora_arch}-%{version}%{?ora_date}.zip
Source2: instantclient-odbc-%{ora_arch}-%{version}%{?ora_date}.zip
Source3: instantclient-sdk-%{ora_arch}-%{version}%{?ora_date}.zip
Source4: instantclient-sqlplus-%{ora_arch}-%{version}%{?ora_date}.zip
NoSource: 0
NoSource: 1
NoSource: 2
NoSource: 3
NoSource: 4
Source10: http://jeanchristophe.duber.free.fr/dbd_oracle_instantclient_linux/oracle-instantclient-config
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root
ExclusiveArch: i386 x86_64

%description
Instant Client for Oracle Database 10g.


%package basic%{?lite}
Summary: Instant Client for Oracle Database 10g
Group: Applications/Databases
%{?lite:Provides: %{name}-basic = %{version}-%{release}}

%description basic%{?lite}
Base files for Instant Client which include support for OCI, OCCI, and JDBC-OCI
applications.


%package devel
Summary: Development headers for Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description devel
Additional header files and an example Makefile for developing Oracle
applications with Instant Client.


%package jdbc
Summary: Supplemental JDBC features under Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description jdbc
Additional support for XA, Internationalization, and RowSet operations under
JDBC in Instant Client.


%package odbc
Summary: ODBC for Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description odbc
Additional libraries for enabling ODBC support in Instant Client.


%package sqlplus
Summary: SQL*Plus for Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description sqlplus
Additional libraries and executable for running SQL*Plus with Instant Client.


%prep
%setup -c %{name}-%{version} -a 1 -a 2 -a 3 -a 4


%build


%install
%{__rm} -rf %{buildroot}

# All the original Oracle files

%{__mkdir_p} %{buildroot}%{_bindir}
%{__mkdir_p} %{buildroot}%{_libdir}/oracle/%{version}/client/bin
%{__mkdir_p} %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
%{__mkdir_p} %{buildroot}%{_includedir}/oracle/%{version}/client/
%{__mkdir_p} %{buildroot}%{_datadir}/oracle/%{version}/client/

# basic/jdbc/odbc/sqlplus
%{__cp} -a %{ora_dir}/{*.so*,*.jar,*.sql} \
    %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}/
%{__cp} -a %{ora_dir}/sqlplus %{ora_dir}/odbc_install.sh \
    %{buildroot}%{_libdir}/oracle/%{version}/client/bin/
%{__ln_s} %{_libdir}/oracle/%{version}/client/bin/sqlplus \
    %{buildroot}%{_bindir}/sqlplus

# devel (sdk)
%{__cp} -a %{ora_dir}/sdk/include/*.h \
    %{buildroot}%{_includedir}/oracle/%{version}/client/
%{__cp} -a %{ora_dir}/sdk/demo/* \
    %{buildroot}%{_datadir}/oracle/%{version}/client/
for file in libclntsh.so libocci.so; do
    pushd %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
    %{__ln_s} ${file}.* ${file}
    popd
done

# All the custom files

# Install the ld.so.conf.d entry for the libs to be found
%{__mkdir_p} %{buildroot}%{_sysconfdir}/ld.so.conf.d
cat > %{buildroot}%{_sysconfdir}/ld.so.conf.d/oracle-instantclient.conf << EOF
%{_libdir}/oracle/%{version}/client/%{_lib}
EOF

# Install the profile.d entry for the env. variable to be set
%{__mkdir_p} %{buildroot}%{_sysconfdir}/profile.d
cat > %{buildroot}%{_sysconfdir}/profile.d/oracle.sh << EOF
#export ORACLE_HOME="%{_libdir}/oracle/%{version}/client"
#export TNS_ADMIN=%{_sysconfdir}
export NLS_LANG=AMERICAN_AMERICA.WE8ISO8859P1
EOF

# Install the config script, replace /opt with /usr, lib and version
%{__install} -D %{SOURCE10} %{buildroot}%{_bindir}/oracle-instantclient-config
%{__perl} -pi -e 's|^prefix=.*|prefix=/usr|g;
                  s|/lib|/%{_lib}|g;
                  s|^version=.*|version=%{version}|g' \
    %{buildroot}%{_bindir}/oracle-instantclient-config


%clean
%{__rm} -rf %{buildroot}


%post basic%{?lite} -p /sbin/ldconfig

%postun basic%{?lite} -p /sbin/ldconfig

%post jdbc -p /sbin/ldconfig

%postun jdbc -p /sbin/ldconfig

%post odbc -p /sbin/ldconfig

%postun odbc -p /sbin/ldconfig

%post sqlplus -p /sbin/ldconfig

%postun sqlplus -p /sbin/ldconfig


%files basic%{?lite}
%defattr(-, root, root, 0755)
# Custom files
%attr(0644, root, root) %config %{_sysconfdir}/ld.so.conf.d/oracle-instantclient.conf
%attr(0755, root, root) %config(noreplace) %{_sysconfdir}/profile.d/oracle.sh
%attr(0755, root, root) %{_bindir}/oracle-instantclient-config
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_libdir}/oracle/%{version}/client/%{_lib}/classes12.jar
%{_libdir}/oracle/%{version}/client/%{_lib}/libclntsh.so.*
%{_libdir}/oracle/%{version}/client/%{_lib}/libnnz10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci.so.*
%{!?lite:%{_libdir}/oracle/%{version}/client/%{_lib}/libociei.so}
%{?lite:%{_libdir}/oracle/%{version}/client/%{_lib}/libociicus.so}
%{_libdir}/oracle/%{version}/client/%{_lib}/libocijdbc10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/ojdbc14.jar

%files devel
%defattr(-, root, root, 0755)
# Custom files
%dir %{_includedir}/oracle/
%dir %{_includedir}/oracle/%{version}/
%dir %{_includedir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
%dir %{_datadir}/oracle/
%dir %{_datadir}/oracle/%{version}/
%dir %{_datadir}/oracle/%{version}/client/
# Original Oracle files
%{_includedir}/oracle/%{version}/client/*.h
%{_libdir}/oracle/%{version}/client/%{_lib}/libclntsh.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci.so
%{_datadir}/oracle/%{version}/client/*

%files jdbc
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_libdir}/oracle/%{version}/client/%{_lib}/libheteroxa10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/orai18n.jar

%files odbc
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/bin/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%doc %{ora_dir}/ODBC*.htm*
%{_libdir}/oracle/%{version}/client/bin/odbc_install.sh
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqora.so.*

%files sqlplus
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/bin/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_bindir}/sqlplus
%{_libdir}/oracle/%{version}/client/bin/sqlplus
%{_libdir}/oracle/%{version}/client/%{_lib}/glogin.sql
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqlplus.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqlplusic.so


%changelog
* Wed May 17 2006 Matthias Saou <http://freshrpms.net/> 10.2.0.2-2
- Replace lib with lib64 on 64bit archs in oracle-instantclient-config (thanks
  to Mindaugas Riauba).

* Mon Apr 24 2006 Matthias Saou <http://freshrpms.net/> 10.2.0.2-1
- Update to 10.2.0.2.

* Fri Nov 18 2005 Matthias Saou <http://freshrpms.net/> 10.2.0.1-7
- Substitute hardcoded version= in oracle-instantclient-config (Stefan Radman).

* Tue Nov 15 2005 Matthias Saou <http://freshrpms.net/> 10.2.0.1-6
- Clean the spec file a bit since we now have the same version for both archs.
- Add ODBC sub-package (Stefan Radman).
- Minor cleanups (Stefan Radman).
- Checked Oracle rpm packages for 10.2.0.1... still badly broken :-(
- Add optional define to use basiclite libraries instead of the full basic
  (you just get a libociicus instead of libociei) - Untested, but should work.

* Thu Nov 10 2005 Matthias Saou <http://freshrpms.net/> 10.2.0.1-5
- Update x86_64 to newly released 10.2.0.1.

* Fri Jul 22 2005 Matthias Saou <http://freshrpms.net/> 10.1.0.3-4
- Add missing ldconfig calls for the jdbc and sqlplus packages.
- Add default export NLS_LANG=AMERICAN_AMERICA.WE8ISO8859P1 to oracle.sh.
- Update i386 to 10.2.0.1-20050713.
- Remove libocci10_296.so.10.1 entirely, it's gone from 10.2.0.1 i386 now.

* Mon Apr 11 2005 Matthias Saou <http://freshrpms.net/> 10.1.0.3-3
- Exclude libocci10_296.so.10.1 only for i386 as it's not present for x86_64.
- Create a lib -> lib64 when libs are in lib64 for libsqlora8 to detect libs.

* Fri Apr  8 2005 Matthias Saou <http://freshrpms.net/> 10.1.0.3-3
- Initial RPM release.

